\".TH "MULTIPLE" "1" "16 December 2000" "" ""
.TH "MULTIPLE" "1" "05 September 2011" "" ""
.SH NAME
multiple \- compares files
.SH SYNOPSIS
.sp
\fBmultiple\fR [ \fB-aivh0d\fR ] 
.SH "DESCRIPTION"
.PP
\fBmultiple\fR compares files, which's names are piped in.
.PP
This program compares files byte-by-byte,
allowing to ignore usenet/mail-headers (with option -i).

This -i option allows to compare the data-contents of different files,
intentionally ignoring headers (e.g. mails or news that used
a different path but contain the same stuff, which would be superflous then,
if saved more than once.)
.PP
Without any Switch/Options given, the files will be selected
by certain rules, which will be described later. This selection-
rules will cause, that only names of superfluous files will be 
printed out. This means that the names of multiple files will be
printed, while files, which only appear once, will not
be mentioned in the output.
In this way, single files will not be mentioned on the output.
.PP
Default behaviour is: ignore files with size == 0.
They might be "flags" on the filesystem level,
for example just touch(1)ed for some reason.
With option -0 this default can be overridden.
.PP
Please notice, that THE CONTENTS of a file, the data INSIDE a file
is considered for comparison. If two files contain the same data, one of them
will be considered as superfluous. So the names of the files
can be different. (This is a different problem then to find files
with same names but located in other directories, containing
different stuff; you would maybe do this with "diff -r".)
.PP
All files, which are detected as "containing equal data", will
be printed in one line. The next equal files will be printed
in another line and so on.
.PP
Please notice:
  *** NEVER use option "-follow"  of the find program. ***                        
                                                                                
Check if it's enabled via an alias, when using                                  
find on an unknown (maybe your own) system, to feed multiple
with filenames.

If you ignore this warning, you may remove ALL your files unintentionally.
So, please be careful.

.PP
Use multiple at your own risk!
.SH "OPTIONS"
.TP
\fB-a\fR
print ALL filenames instead of superfluous

If this Option is NOT switched on (default),
only selected filenames will be printed. 
The Selection will be described later.
.TP
\fB-i\fR
compare after first empty line (IGNORE headers)

Compare AFTER Headers bytewise. If this Option is switched 
on and no header is found in the files (EOF before the first
blank line), the files will be ignored.
If a file has no (mail-/news-) headerlike section,
the file will be ignored.
.TP
\fB-v\fR
Show version number and exit
.TP
\fB-h\fR
Show help message
.TP
\fB-0\fR
don't ignore files with size == 0
.TP
\fB-d\fR
delete superflous files and print name of the non-deleted files.
Attention! This option ignores read-only-permissions of your files!

Option -d and -a are not allowed to be uses both at the same time.
You will get an error message if you try to use this combination.
That's for security, not to delete ALL equal files,
so that at least one original file remains (and which it is
will be printed).

.SH "EXAMPLE"
.PP
\fBfind mydir -name "*.txt" -print | multiple\fR
.SH "BUGS"
.PP
Mail me if you find any.
.SH "AUTHOR"
.PP
Oliver Bandel <oliver@first.in-berlin.de>
.SH "SEE ALSO"

\fBfind(1L)\fR
